﻿package  scenes
{
	import adobe.utils.CustomActions;
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.executors.*;
	import jp.progression.Progression;
	import jp.progression.scenes.*;
	import ui.AboutButton;
	import ui.GalleryButton;
	import ui.HomeButton;
	import ui.ProgressionButton;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class IndexScene extends SceneObject 
	{
		private var aboutScene:AboutScene;
		private var galleryScene:GalleryScene;
		private var homeButton:HomeButton;
		private var aboutButton:AboutButton;
		private var galleryButton:GalleryButton;
		private var progressionButton:ProgressionButton;
		/**
		 * 新しい IndexScene インスタンスを作成します。
		 */
		public function IndexScene() 
		{
			// シーンタイトルを設定します。
			title = "Porject_sdk";
			
			aboutScene = new AboutScene( "about" );
			addScene( aboutScene );
			galleryScene = new GalleryScene( "gallery" );
			addScene( galleryScene );
			
			homeButton = new HomeButton();
			aboutButton = new AboutButton();
			galleryButton = new GalleryButton();
			progressionButton = new ProgressionButton();
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void 
		{
			addCommand(
				new AddChild( container , progressionButton ),
				[
				new AddChild( container , homeButton ),
				new AddChild( container , aboutButton ),
				new AddChild( container , galleryButton )
				]
			);
		}
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更される直前に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneUnload():void 
		{
			addCommand(
				new RemoveChild( container , homeButton ),
				new RemoveChild( container , aboutButton ),
				new RemoveChild( container , galleryButton ),
				new RemoveChild( container , progressionButton )
			);
		}
	}
}
