package ui 
{
	import flash.display.Bitmap;
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.scenes.*;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class FrenchButton extends CastButton 
	{
		[Embed(source = "../images/frenchButton.png")]
		private var Emb:Class;
		/**
		 * 新しい FrenchButton インスタンスを作成します。
		 */
		public function FrenchButton( initObject:Object = null ) 
		{
			// 親クラスを初期化します。
			super( initObject );
			
			// 移動先となるシーン識別子を設定します。
			sceneId = new SceneId( "/index/gallery/french" );
			
			var img:Bitmap = new Emb() as Bitmap;
			addChild( img );
		}
		
		/**
		 * IExecutable オブジェクトが AddChild コマンド、または AddChildAt コマンド経由で表示リストに追加された場合に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastAdded():void 
		{
			x = 270;
			y = 161;
			alpha = 0;
			addCommand(
				new DoTweener( this , { alpha:1 , time:.2 } )
			);
		}
		
		/**
		 * IExecutable オブジェクトが RemoveChild コマンド、または RemoveAllChild コマンド経由で表示リストから削除された場合に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRemoved():void 
		{
			addCommand(
				new DoTweener( this , { alpha:0 , time:.2 } )
			);
		}
	}
}
