package ui 
{
	import flash.display.Bitmap;
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.scenes.*;
	import pages.Effect;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class GalleryButton extends CastButton 
	{
		[Embed(source = "../images/galleryButton.png")]
		private var Emb:Class;
		private var effect:Effect;
		/**
		 * 新しい GalleryButton インスタンスを作成します。
		 */
		public function GalleryButton( initObject:Object = null ) 
		{
			// 親クラスを初期化します。
			super( initObject );
			
			var img:Bitmap = new Emb() as Bitmap;
			addChild( img );
			
			// 移動先となるシーン識別子を設定します。
			sceneId = new SceneId( "/index/gallery" );
			
			effect = new Effect();
		}
		
		/**
		 * IExecutable オブジェクトが AddChild コマンド、または AddChildAt コマンド経由で表示リストに追加された場合に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastAdded():void 
		{
			x = -70;
			y = 254;
			alpha = 0;
			addCommand(
				new DoTweener( this , { alpha:1 , x:0 , time:.3 , transition:"easeOutCirc" } )
			);
		}
		/**
		 * ユーザーが CastButton インスタンスにポインティングデバイスを合わせたときに送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRollOver():void 
		{
			addCommand(
				new AddChild( this , effect )
			);
		}
		
		/**
		 * ユーザーが CastButton インスタンスからポインティングデバイスを離したときに送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRollOut():void 
		{
			addCommand(
				new RemoveChild( this , effect )
			);
		}
	}
}
